' `؏ŕϓo Ver. 2.12
' (c) 2015-2024 ˂悵, CC-BY
' https://tsume-kobo.org/hendochk/
'  V0.01 2015/7/5
'  V1.00 2016/4/10
'  V2.12 2024/2/17

Option Explicit
Const cs_ThisVersion = "Ver 2.12"

Dim o_WSH, o_FSO, o_FileIO, o_Console, o_KANKYO, o_KifIO, o_LockFile ' APIpIuWFNgȂ

Call ToCscript()
Call Main()
Call WScript.Quit()

Private Sub ToCscript()
    If UCase(Right(WScript.FullName,11)) = "CSCRIPT.EXE" Then Exit Sub
    Dim Arg, RunStr
    RunStr = "%comspec% /c Title ϓ`FbN " & cs_ThisVersion & " & CScript.exe """ & WScript.ScriptFullName & """"
    For Each Arg In WScript.Arguments
        RunStr = RunStr & " """ & Arg & """"
    Next
    Call CreateObject("WScript.Shell").Run(RunStr)
    Call WScript.Quit()
End Sub

Private Sub Main()
    Dim s_CuDir ' c[̃pX
    Dim s_Kif_Files, v_Kif_Evaluate(), s_FolderName(), i_Kif_File_Count

    Set o_WSH = CreateObject("WScript.Shell")
    Set o_FSO = CreateObject("Scripting.FileSystemObject")
    s_CuDir = o_FSO.getParentFolderName(WScript.ScriptFullName)
    o_WSH.CurrentDirectory = s_CuDir

    Set o_FileIO = New FileIO
    Set o_Console = New clsConsole
    Set o_LockFile = New LockFile ' dNh~t@C
    Set o_KANKYO = New KANKYO_Data
    Set o_KifIO = New clsKif_FileIO

    s_Kif_Files = o_KifIO.FileList()
    i_Kif_File_Count = UBound(s_Kif_Files)
    ReDim v_Kif_Evaluate(i_Kif_File_Count), s_FolderName(i_Kif_File_Count)
    Dim i, j
    For i = 0 To i_Kif_File_Count
        s_FolderName(i) = Replace(Replace(o_FSO.getFileName(s_Kif_Files(i)), " ", "_"), ".", "_") ' kift@CۑtH_𐶐(󔒂ƃsIh)
        If o_FSO.FolderExists(s_FolderName(i)) Then ' ÂmFʂcĂ
            Call o_Console.MsgExclamation("mFʂcĂ̂Œf܂Bi" & s_FolderName(i) & "j" _
                & vbCrLf & "mFʂړ܂͍폜ĎsĂB")
        End If
    Next
    For i = 0 To i_Kif_File_Count
        Call WScript.Echo(vbCrLf & "OF" & s_Kif_Files(i) & vbCrLf)
        v_Kif_Evaluate(i) = o_KifIO.Evaluate(s_Kif_Files(i))
        If v_Kif_Evaluate(i)(0) < 2 Then Call o_Console.MsgExclamation("kift@CɌΏۂ̕ω܂B" & vbCrLf & s_Kif_Files(i))
        For j = v_Kif_Evaluate(i)(0) To 1 Step -1
            If v_Kif_Evaluate(i)(j).Count > 0 Then Exit For
        Next
        If j < 1 Then Call o_Console.MsgExclamation("kift@CɌΏۂ̕ω܂B" & vbCrLf & s_Kif_Files(i))
    Next
    Dim s_ResultText
    s_ResultText = "`؏ŕϓ`FbN " & cs_ThisVersion
    For i = 0 To i_Kif_File_Count
        o_WSH.CurrentDirectory = o_FSO.CreateFolder(s_CuDir & "\" & s_FolderName(i))
        Call o_FSO.CopyFile(s_Kif_Files(i), o_WSH.CurrentDirectory & "\")
        s_ResultText = s_ResultText & vbCrLf & vbCrLf & (New clsResult).Solve(v_Kif_Evaluate(i), s_Kif_Files(i))
        v_Kif_Evaluate(i) = Empty
    Next
    If i_Kif_File_Count > 0 Then
        Call o_FileIO.WriteText(s_CuDir & "\Hendo_Kekka_" & Replace(Replace(Replace(Now(), "/", ""), ":", ""), " ", "_") & ".txt", s_ResultText)
    End If
    Call o_Console.MsgInfo("I܂B")
End Sub

' *** NX

Dim clsResultTempFiles ' fXgN^pi܂ŕێjPublic錾

Const cs_TANTESU_Folder = "AZ萔"
Const cs_DOUTESU_Folder = "B萔]"
Const cs_HENDO_Folder = "C萔Ȃ"
Const cs_AITORI_Folder = "DQ蒷"
Const cs_HENCHO_Folder = "E萔"
Const cs_MIKENTO_Folder = "Fω"

Class clsResult

    Private po_KAKINOKI
    Private s_TempFolderName

    Private Sub Class_Initialize()
        Set clsResultTempFiles = New TempFiles
        s_TempFolderName = clsResultTempFiles.FolderName & "\"
        Set po_KAKINOKI = New clsKAKINOKI
    End Sub

    Public Function Solve(ByVal v_K_Buf, ByVal s_Kif_FileName)
        Dim i_TESU, i_SHURYO_TESU, i_H_TESU, i_SOBUNKI, i, s_S
        Dim a_Kif_File_List(), a_H_TESU_List(), i_Kif_Count

        i_SOBUNKI = 0
        For i = 1 To v_K_Buf(0)
            i_SOBUNKI = i_SOBUNKI + v_K_Buf(i).Count
        Next
        ReDim a_Kif_File_List(i_SOBUNKI)
        Redim a_H_TESU_List(i_SOBUNKI)

        a_Kif_File_List(0) = s_Kif_FileName
        o_Console.Kif_FileName = s_Kif_FileName

        i_Kif_Count = 1
        o_Console.BUNKISU = i_SOBUNKI
        o_Console.SOTESU = v_K_Buf(0)
        o_Console.BANMEN = v_K_Buf(1).Text_K(-1) ' -1=ݔՖ
        i_SHURYO_TESU = v_K_Buf(0) - 1
        For i_TESU = 2 - (i_SHURYO_TESU Mod 2) To i_SHURYO_TESU Step 2
            i_H_TESU = v_K_Buf(0) - i_TESU
            For i = 1 To v_K_Buf(i_TESU).Count
                Call o_Console.IncKYOKUMENSU()
                s_S = v_K_Buf(i_TESU).Text_K(i)
                o_Console.BANMEN = s_S
                a_Kif_File_List(i_Kif_Count) = Create_Kif_File(s_S, i_TESU, v_K_Buf(i_TESU).TE_Text(i))
                a_H_TESU_List(i_Kif_Count) = i_H_TESU
                Call po_KAKINOKI.getResult(a_Kif_File_List(i_Kif_Count))
                i_Kif_Count = i_Kif_Count + 1
            Next
            Call o_Console.IncIncTE()
        Next
        Call o_Console.Finish()
        Call KETSUGO(v_K_Buf(0), a_Kif_File_List, a_H_TESU_List)
        Solve = o_Console.Closing()
    End Function

    Private Function Create_Kif_File(ByVal s_BAN, ByVal i_TESU, ByVal s_TE) ' KifFile𐶐ăt@CԂ
        Create_Kif_File = s_TempFolderName & Right("000" & i_TESU, 4) & s_TE & ".kif"
        Call o_FileIO.WriteText(Create_Kif_File, s_BAN)
    End Function

    Private Sub KETSUGO(ByVal i_SOTESU, ByVal a_Kif_File_List, ByVal a_H_TESU_List)
        Dim s_SKFileText, s_OKFileText, s_OKFileTextLine, s_FolderName
        Dim s_OFN, s_OFNS, i_TE, i_TE2, i_SKL, i_OKL, i_OKLend, s_WText, s_S
        With o_FSO
            Call .CreateFolder(cs_HENDO_Folder)
            Call .CreateFolder(cs_DOUTESU_Folder)
            Call .CreateFolder(cs_HENCHO_Folder)
            Call .CreateFolder(cs_AITORI_Folder)
            Call .CreateFolder(cs_TANTESU_Folder)
            Call .CreateFolder(cs_MIKENTO_Folder)
        End With
        s_OKFileText = o_FileIO.ReadText(a_Kif_File_List(0))
        s_OKFileTextLine = Split(s_OKFileText, vbCrLf)
        i_OKLend = UBound(s_OKFileTextLine)
        s_WText = ""
        i_SKL = UBound(a_Kif_File_List)
        For i_OKL = 0 To i_OKLend
            s_WText = s_WText & s_OKFileTextLine(i_OKL) & vbCrLf
            If Left(s_OKFileTextLine(i_OKL), 2) = "܂" Then Exit For
        Next
        For i_TE = i_SOTESU To 1 Step -1
            If (i_TE Mod 2) <> (i_SOTESU Mod 2) Then ' 󂯕
                For i_SKL = i_SKL To 1 Step -1
                    s_OFN = a_Kif_File_List(i_SKL)
                    s_OFNS = o_FSO.getFileName(s_OFN)
                    If i_TE <> CInt(Left(s_OFNS, 4)) Then Exit For ' i_TEɐi
                    s_SKFileText = o_FileIO.ReadText(s_OFN)
                    s_FolderName = BUNRUI(s_SKFileText, s_OFN, a_H_TESU_List(i_SKL))
                    s_WText = s_WText & vbCrLf & "ωF" & i_TE & "" & vbCrLf
                    s_S = Right("   " & i_TE, 4) & " " _
                       & Mid("PQRSTUVWX", CInt(Mid(s_OFNS, 6, 1)), 1) _
                       & Mid("OlܘZ", CInt(Mid(s_OFNS, 7, 1)), 1) '򂵂ωt@C畜
                    If Mid(s_OFNS, 9, 1) = "Q" Then ' łłłȂ
                        s_S = s_S & Mid(s_OFNS, 8, 1)
                    Else
                        s_S = s_S & Mid(s_OFNS, 8, 2)
                    End If
                    If IsNumeric(Mid(s_OFNS, 10, 2)) Then s_S = s_S & "(" & Mid(s_OFNS, 10, 2) & ")"
                    s_WText = s_WText & s_S & vbCrLf & "*" & s_FolderName & vbCrLf & "*hendochk " & cs_ThisVersion & vbCrLf ' v1.11 Rg̒ǋL
                    i_TE2 = 1
                    For Each s_S In Split(s_SKFileText, vbCrLf)
                        If Left(s_S, 2) = "܂" Then
                            s_WText = s_WText & "܂" & (i_TE + i_TE2 - 2) & "l" & vbCrLf
                            Exit For
                        ElseIf IsNumeric(Left(s_S, 4)) Then
                            If CInt(Left(s_S, 4)) = i_TE2 Then
                                s_WText = s_WText & Right("   " & (i_TE + i_TE2), 4) & Mid(s_S, 5) & vbCrLf
                                i_TE2 = i_TE2 + 1
                            End If
                        End If
                    Next
                Next
            Else ' Uߕ
                For i_OKL = i_OKL To i_OKLend
                    s_S = s_OKFileTextLine(i_OKL)
                    If Left(s_S, 2) = "ω" Then
                        If CInt(Split(Mid(s_S, 4), "")(0)) < i_TE Then
                            Exit For
                        ElseIf CInt(Split(Mid(s_S, 4), "")(0)) = i_TE Then
                            s_WText = s_WText & vbCrLf & s_S & vbCrLf
                            Do While i_OKL < i_OKLend
                                i_OKL = i_OKL + 1
                                If s_OKFileTextLine(i_OKL) = "" Then Exit Do
                                s_WText = s_WText & s_OKFileTextLine(i_OKL) & vbCrLf
                                If Left(s_OKFileTextLine(i_OKL), 2) = "܂" Then Exit Do
                            Loop
                        End If
                    End If
                Next
            End If
        Next
        Call o_FileIO.WriteText("ketsugo.kif", s_WText)
    End Sub

    Private Function BUNRUI(ByVal s_Kif_FileText, ByVal s_Kif_FileName, ByVal i_H_TESU) ' s_Kif_FileText𒲂ׂs_Kif_FileName𕪗ނ
        Dim s_TETo, i, i_TSUME_TESU, s_S, v_Eval
        v_Eval = o_KifIO.EvaluateText(s_Kif_FileText)
        If IsEmpty(v_Eval) Then ' ĂȂ
            BUNRUI = cs_MIKENTO_Folder
            Call o_Console.IncTimeout()
        Else
            s_S = Right(s_Kif_FileName, 10) ' t@C璅蕔o
            i_TSUME_TESU = UBound(v_Eval)
            If v_Eval(i_TSUME_TESU).IsAMARI(0) Then
                i_TSUME_TESU = i_TSUME_TESU - 1 ' ]̋l̂Ƃ
            End If
            If i_TSUME_TESU = i_H_TESU Then ' 萔]Ȃ
                BUNRUI = cs_HENDO_Folder
                Call o_Console.IncHENDO()
            ElseIf i_TSUME_TESU + 1 = i_H_TESU Then ' 萔]
                BUNRUI = cs_DOUTESU_Folder
            ElseIf (i_TSUME_TESU - 1 = i_H_TESU) And (InStr(s_S, "") > 0) Then '2蒷
                s_TETo = CInt(Mid(s_S, 2, 1) & Left(s_S, 1))
                If (s_TETo = v_Eval(1).getTo()) And (s_TETo <> v_Eval(2).getTo()) Then ' PڂŎuvłȂ
                    BUNRUI = cs_AITORI_Folder
                    Call o_Console.IncHENCHO()
                Else
                    BUNRUI = cs_HENCHO_Folder
                    Call o_Console.IncHENCHO()
                End If
            ElseIf i_TSUME_TESU > i_H_TESU Then 'ϒ
                BUNRUI = cs_HENCHO_Folder
                Call o_Console.IncHENCHO()
            Else
                BUNRUI = cs_TANTESU_Folder
            End If
        End If
        Call o_FileIO.Copy(s_Kif_FileName, BUNRUI & "\")
    End Function

End Class

' *** Ւ`NX

Class clsSHOGIBAN

    Private ps_BAN(120), pi_MOCHI(1, 7), pi_TEBAN, pb_NIFU(9), pi_From(), pi_To(), ps_KOMA(), p_MaxTE

    Public Default Property Get Set_BAN(byVal s_BAN, byVal i_MOCHI, byVal i_TEBAN, byVal i_From, byVal i_To, byVal s_KOMA)
        Dim i, n, gg, sg, i_KOMAcount(8), b_sNIFU(9)
        Const ci_MaxBUNKI = 1000 ' 1ǖʂ̍ő啪򐔁ij
        ReDim pi_From(ci_MaxBUNKI), pi_To(ci_MaxBUNKI), ps_KOMA(ci_MaxBUNKI)
        p_MaxTE = 0
        Set Set_BAN = Nothing
        If Not IsEmpty(pi_TEBAN) Then Exit Property
        If (i_From <> 0) And ((i_From < 11) Or (i_From > 99) Or (i_From Mod 10 = 0)) Then Exit Property
        If (i_To < 11) Or (i_To > 99) Or (i_To Mod 10 = 0) Then Exit Property
        gg = False
        sg = False
        For i = 1 To 9
            pb_NIFU(i) = True
            b_sNIFU(i) = True
        Next
        For i = 1 To 7
            i_KOMAcount(i) = 0
        Next
        If IsEmpty(s_BAN(0)) Then
            For i = 0 To 120
                ps_BAN(i) = ""
            Next
        End If
        For i = 11 To 99
            If (i Mod 10) = 0 Then i = i + 1
            Select Case s_BAN(i)
                Case "v"
                    If i > 90 Then Exit Property
                    If Not pb_NIFU(i Mod 10) Then Exit Property
                    pb_NIFU(i Mod 10) = False
                Case "v"
                    If i > 90 Then Exit Property
                Case "vj"
                    If i > 80 Then Exit Property
                Case "v"
                    If gg Then Exit Property
                    gg = True
                Case " "
                    If i < 20 Then Exit Property
                    If Not b_sNIFU(i Mod 10) Then Exit Property
                    b_sNIFU(i Mod 10) = False
                Case " "
                    If i < 20 Then Exit Property
                Case " j"
                    If i < 30 Then Exit Property
                Case " "
                    If sg Then Exit Property
                    sg = True
            End Select
            ps_BAN(i) = s_BAN(i)
            n = KOMA2Num(Right(s_BAN(i), 1))
            If n > 0 Then
                i_KOMAcount(n) = i_KOMAcount(n) + 1
            End If
        Next
        If Not gg Then Exit Property
        pi_TEBAN = i_TEBAN
        If Is_OTE(s_BAN) Xor (pi_TEBAN = 1) Then Exit Property
        For i = 1 To 7
            pi_MOCHI(0, i) = i_MOCHI(0, i)
            pi_MOCHI(1, i) = i_MOCHI(1, i)
            i_KOMAcount(i) = i_KOMAcount(i) + i_MOCHI(0, i) + i_MOCHI(1, i)
            Select Case i
                Case 1
                    If i_KOMAcount(1) > 18 Then Exit Property
                Case 6
                    If i_KOMAcount(6) > 2 Then Exit Property
                Case 7
                    If i_KOMAcount(7) > 2 Then Exit Property
                Case Else
                    If i_KOMAcount(i) > 4 Then Exit Property
            End Select
        Next
        pi_From(0) = i_From
        pi_To(0) = i_To
        ps_KOMA(0) = s_KOMA
        If pi_TEBAN = 1 Then
            If Not BUNKI_Set(ps_BAN, pi_MOCHI) Then
                Exit Property
            End If
        End If
        ReDim Preserve pi_From(p_MaxTE), pi_To(p_MaxTE), ps_KOMA(p_MaxTE)
        Set Set_BAN = Me
    End Property

    Private Function BUNKI_Set(ByVal s_sBAN, ByVal s_iMOCHI)
        Dim i_ICHI, i, s_BAN, b_AIYUKO(99), s_K, i_Perform, s_N, b_RENZOKU, b_RENZOKU_R, i_RENZOKU_IDO, i_IDOSAKI_ICHI
        For i_ICHI = 11 To 99
            b_AIYUKO(i_ICHI) = True
        Next
        BUNKI_Set = False
        For i_ICHI = 11 To 99
            If (i_ICHI Mod 10) = 0 Then i_ICHI = i_ICHI + 1
            If IsEmpty(s_iMOCHI) Then Exit For
            If s_sBAN(i_ICHI) = " E" Then ' 󔒃}Xɋ
                For i = 7 To 4 Step -1
                    If (s_iMOCHI(0, i) > 0) And b_AIYUKO(i_ICHI) Then
                        s_BAN = s_sBAN
                        s_BAN(i_ICHI) = "v" & Mid("jp", i, 1)
                        If Is_OTE(s_BAN) Then
                            b_AIYUKO(i_ICHI) = False
                        Else
                            If writeBUNKI(0, i_ICHI, Mid("jp", i, 1)) Then BUNKI_Set = True
                        End If
                    End If
                Next
                If (i_ICHI < 80) And (s_iMOCHI(0, 3) > 0) And b_AIYUKO(i_ICHI) Then
                    s_BAN = s_sBAN
                    s_BAN(i_ICHI) = "vj"
                    If Is_OTE(s_BAN) Then
                        b_AIYUKO(i_ICHI) = False
                    Else
                        If writeBUNKI(0, i_ICHI, "j") Then BUNKI_Set = True
                    End If
                End If
                If (i_ICHI < 90) And (s_iMOCHI(0, 2) > 0) And b_AIYUKO(i_ICHI) Then
                    s_BAN = s_sBAN
                    s_BAN(i_ICHI) = "v"
                    If Is_OTE(s_BAN) Then
                        b_AIYUKO(i_ICHI) = False
                    Else
                        If writeBUNKI(0, i_ICHI, "") Then BUNKI_Set = True
                    End If
                End If
                If pb_NIFU(i_ICHI Mod 10) And (i_ICHI < 90) And (s_iMOCHI(0, 1) > 0) And b_AIYUKO(i_ICHI) Then
                    s_BAN = s_sBAN
                    s_BAN(i_ICHI) = "v"
                    If Not Is_OTE(s_BAN) Then
                        If s_BAN(i_ICHI + 10) <> " " Then
                            BUNKI_Set = BUNKI_Set Or writeBUNKI(0, i_ICHI, "")
                        Else ' Uʑłl̃`FbN
                            If BUNKI_Set(ReverseBAN(s_BAN), Empty) Then ' Empty `FbN̂
                                If writeBUNKI(0, i_ICHI, "") Then BUNKI_Set = True
                            End If
                        End If
                    End If
                End If
            End If
        Next
        For i_ICHI = 11 To 99
            If (i_ICHI Mod 10) = 0 Then i_ICHI = i_ICHI + 1
            If Left(s_sBAN(i_ICHI), 1) = "v" Then
                s_K = Right(s_sBAN(i_ICHI), 1)
                s_N = KOMA2NARI(s_K)
                For Each i_Perform In KOMA_Perform(s_K)
                    Select Case i_Perform
                        Case 8888
                            b_RENZOKU_R = True
                        Case 9999
                            b_RENZOKU_R = False
                        Case Else
                            b_RENZOKU = b_RENZOKU_R
                            i_RENZOKU_IDO = i_Perform
                            Do
                                i_IDOSAKI_ICHI = i_ICHI + i_RENZOKU_IDO
                                If (i_IDOSAKI_ICHI < 11) Or (i_IDOSAKI_ICHI > 99) Then Exit Do
                                If s_sBAN(i_IDOSAKI_ICHI) <> " E" Then b_RENZOKU = False
                                If (Left(s_sBAN(i_IDOSAKI_ICHI), 1) = " ") And ((s_sBAN(i_ICHI) = "v") Or (s_sBAN(i_IDOSAKI_ICHI) <> " E") Or b_AIYUKO(i_IDOSAKI_ICHI)) Then
                                    If (i_IDOSAKI_ICHI < 80) Or ((i_IDOSAKI_ICHI < 90) And (s_K <> "j")) Or ((s_K <> "") And (s_K <> "") And (s_K <> "j")) Then
                                        s_BAN = s_sBAN
                                        s_BAN(i_IDOSAKI_ICHI) = s_BAN(i_ICHI)
                                        s_BAN(i_ICHI) = " E"
                                        If Not Is_OTE(s_BAN) Then
                                            If IsEmpty(s_iMOCHI) Then
                                                BUNKI_Set = True
                                                Exit Function
                                            End If
                                            If writeBUNKI(i_ICHI, i_IDOSAKI_ICHI, s_K) Then BUNKI_Set = True
                                        End If
                                    End If
                                    If (s_N <> "N") And (i_IDOSAKI_ICHI > 70 Or i_ICHI > 70) Then
                                        s_BAN = s_sBAN
                                        s_BAN(i_IDOSAKI_ICHI) = "v" & s_N
                                        s_BAN(i_ICHI) = " E"
                                        If Not Is_OTE(s_BAN) Then
                                            If IsEmpty(s_iMOCHI) Then
                                                BUNKI_Set = True
                                                Exit Function
                                            End If
                                            If writeBUNKI(i_ICHI, i_IDOSAKI_ICHI, s_K & "") Then BUNKI_Set = True
                                        End If
                                    End If
                                End If
                                i_RENZOKU_IDO = i_RENZOKU_IDO + i_Perform
                            Loop While b_RENZOKU
                    End Select
                Next
            End If
        Next
    End Function
    Private Function ReverseBAN(ByVal s_BAN) ' ]Ֆʂ̐iUŕ`FbNpj
        Dim i, s_S, s_rBAN
        s_rBAN = s_BAN
        For i = 11 To 99
            If (i Mod 10) = 0 Then i = i + 1
            s_S = s_BAN(i)
            If s_S = " E" Then
                s_rBAN(110 - i) = " E"
            ElseIf Left(s_S, 1) = "v" Then
                s_rBAN(110 - i) = " " & Right(s_S, 1)
            Else
                s_rBAN(110 - i) = "v" & Right(s_S, 1)
            End If
        Next
		ReverseBAN = s_rBAN ' v2.11
    End Function

    Private Function writeBUNKI(ByVal i_F, ByVal i_T, ByVal s_K)
        If (pi_From(0) = i_F) And (pi_To(0) = i_T) And (ps_KOMA(0) = s_K) Then
            writeBUNKI = True
        Else
            writeBUNKI = False
            p_MaxTE = p_MaxTE + 1
            pi_From(p_MaxTE) = i_F
            pi_To(p_MaxTE) = i_T
            ps_KOMA(p_MaxTE) = s_K
        End If
    End Function

    Public Function Next_Ban(ByVal i_From, ByVal i_To, ByVal s_KOMA) ' 1i߂ՃNX擾
        Dim s_BAN, i_MOCHI, i_TEBAN
        s_BAN = ps_BAN
        i_MOCHI = pi_MOCHI
        i_TEBAN = 1 - pi_TEBAN
        Call Inc_BAN(s_BAN, i_MOCHI, i_TEBAN, pi_From(0), pi_To(0), ps_KOMA(0))
        Set Next_Ban = (New clsSHOGIBAN)(s_BAN, i_MOCHI, i_TEBAN, i_From, i_To, s_KOMA)
    End Function

    Public Function Text_K(ByVal x) ' xi߂Ƃ̔ՖʃeLXg擾Bx<=0̂ƂݔՖʂ擾
        Dim s_BAN, i_MOCHI, i_GYO, i_ICHI
        s_BAN = ps_BAN
        i_MOCHI = pi_MOCHI
        If x > 0 Then Call Inc_BAN(s_BAN, i_MOCHI, (1 - pi_TEBAN), pi_From(x), pi_To(x), ps_KOMA(x))
        Text_K = "̎F" & strMS(0, i_MOCHI) & vbCrLf & "+---------------------------+" & vbCrLf
        For i_GYO = 10 To 90 Step 10
            Text_K = Text_K & "|"
            For i_ICHI = i_GYO + 9 To i_GYO + 1 Step -1
                Text_K = Text_K & s_BAN(i_ICHI)
            Next
            Text_K = Text_K & "|" & vbCrLf
        Next
        Text_K = Text_K & "+---------------------------+" & vbCrLf & "̎F" & strMS(1, i_MOCHI)
    End Function

    Public Function IsAMARI(ByVal x) ' xi߂Ƃ̍U]𒲂ׂ
        Dim s_BAN, i_MOCHI, i_GYO, i_ICHI, i
        s_BAN = ps_BAN
        i_MOCHI = pi_MOCHI
        Call Inc_BAN(s_BAN, i_MOCHI, (1 - pi_TEBAN), pi_From(x), pi_To(x), ps_KOMA(x))
        IsAMARI = True
        For i = 1 To 7
            If i_MOCHI(1, i) > 0 Then Exit Function
        Next
        IsAMARI = False
    End Function

    Public Function getTo() ' ʒuo
        getTo = pi_To(0)
    End Function

    Private Sub Inc_BAN(ByRef s_BAN, ByRef i_MOCHI, ByVal i_TEBAN, ByVal i_From, ByVal i_To, ByVal s_KOMA) ' i߂ĔՖʂByRefŕԂ
        Dim n
        n = KOMA2Num(Left(s_KOMA, 1))
        If i_From = 0 Then   'ł
            s_BAN(i_To) = Mid("v ", i_TEBAN + 1, 1) & s_KOMA
            i_MOCHI(i_TEBAN, n) = i_MOCHI(i_TEBAN, n) - 1
        Else
            n = KOMA2Num(Right(s_BAN(i_To), 1))
            If n > 0 Then    '
                i_MOCHI(i_TEBAN, n) = i_MOCHI(i_TEBAN, n) + 1
            End If
            If Len(s_KOMA) = 1 Then
                s_BAN(i_To) = Mid("v ", i_TEBAN + 1, 1) & s_KOMA ' ł͂Ȃ
            Else
                s_BAN(i_To) = Mid("v ", i_TEBAN + 1, 1) & KOMA2NARI(Left(s_KOMA, 1))  ' 
            End If
            s_BAN(i_From) = " E"
        End If
    End Sub
    Private Function KOMA2Num(ByVal s_S)
        KOMA2Num = InStr("jp", s_S)
        If KOMA2Num = 0 Then KOMA2Num = InStr("ƈǌ\Sn", s_S)
    End Function
    Private Function KOMA2NARI(ByVal s_S) ' Ȃ琬AłȂNԂ
        KOMA2NARI = Mid("Nƈǌ\Sn", InStr("jp", s_S) + 1, 1)
    End Function
    Private Function strMS(ByVal i_TBN, ByVal i_MOCHI) ' eLXgɕϊ
        Dim i, n
        strMS = ""
        For i = 7 To 1 Step -1
            n = i_MOCHI(i_TBN, i)
            If n = 1 Then
                strMS = strMS & Mid("jp", i, 1) & "@"
            ElseIf n > 1 Then
                strMS = strMS & Mid("jp", i, 1) & Num2KANSUJI(n) & "@"
            End If
        Next
        If strMS = "" Then strMS = "Ȃ"
    End Function
    Private Function Num2KANSUJI(ByVal n)
        If n > 10 Then
            Num2KANSUJI = "\" & Mid("OlܘZ", n - 10, 1)
        Else
            Num2KANSUJI = Mid("OlܘZ\", n, 1)
        End If
    End Function

    Public Function TE_Text(ByVal x) ' i[pkift@Cp̃eLXg
        If pi_From(x) = 0 Then
            TE_Text = "_" & (pi_To(x) Mod 10) & Int(pi_To(x) / 10) & ps_KOMA(x) & "__"
        Else
            TE_Text = "_" & (pi_To(x) Mod 10) & Int(pi_To(x) / 10) & Left(ps_KOMA(x) & "Q", 2) & (pi_From(x) Mod 10) & Int(pi_From(x) / 10)
        End If
    End Function

    Public Function Count() ' ̍ő吔iӈȊOj擾
        Count = p_MaxTE
    End Function

    Private Function Is_OTE(ByVal s_BAN) ' Ֆʂ̋ʕʂւ̉
        Dim i_ICHI, b_RENZOKU, b_RENZOKU_R, i_RENZOKU_IDO, i_ICHI_After, i_Perform
        For i_ICHI = 11 To 99
            If (i_ICHI Mod 10) = 0 Then i_ICHI = i_ICHI + 1
            If (s_BAN(i_ICHI) <> " E") And (Left(s_BAN(i_ICHI), 1) = " ") Then
                For Each i_Perform In KOMA_Perform(Right(s_BAN(i_ICHI), 1))
                    Select Case i_Perform
                        Case 8888
                            b_RENZOKU_R = True
                        Case 9999
                            b_RENZOKU_R = False
                        Case Else
                            b_RENZOKU = b_RENZOKU_R
                            i_RENZOKU_IDO = i_Perform
                            Do
                                i_ICHI_After = i_ICHI - i_RENZOKU_IDO
                                If (i_ICHI_After < 11) Or (i_ICHI_After > 99) Then
                                    b_RENZOKU = False
                                Else
                                    Select Case s_BAN(i_ICHI_After)
                                        Case "v"
                                            Is_OTE = True
                                            Exit Function
                                        Case " E"
                                            i_RENZOKU_IDO = i_RENZOKU_IDO + i_Perform
                                        Case Else
                                            b_RENZOKU = False
                                    End Select
                                End If
                            Loop While b_RENZOKU
                    End Select
                Next
            End If
        Next
        Is_OTE = False
    End Function

    Private Function KOMA_Perform(ByVal s_KOMA)
        Select Case s_KOMA
            Case ""
                KOMA_Perform = Array(9999, 10)
            Case ""
                KOMA_Perform = Array(8888, 10)
            Case "j"
                KOMA_Perform = Array(9999, 19, 21)
            Case ""
                KOMA_Perform = Array(9999, -9, -11, 9, 10, 11)
            Case ""
                KOMA_Perform = Array(9999, -10, -1, 1, 9, 10, 11)
            Case "p"
                KOMA_Perform = Array(8888, -9, -11, 9, 11)
            Case ""
                KOMA_Perform = Array(8888, -10, -1, 1, 10)
            Case ""
                KOMA_Perform = Array(9999, -10, -1, 1, 9, 10, 11)
            Case ""
                KOMA_Perform = Array(9999, -10, -1, 1, 9, 10, 11)
            Case "\"
                KOMA_Perform = Array(9999, -10, -1, 1, 9, 10, 11)
            Case "S"
                KOMA_Perform = Array(9999, -10, -1, 1, 9, 10, 11)
            Case "n"
                KOMA_Perform = Array(8888, -9, -11, 9, 11, 9999, -10, -1, 1, 10)
            Case ""
                KOMA_Perform = Array(8888, -10, -1, 1, 10, 9999, -9, -11, 9, 11)
            Case ""
                KOMA_Perform = Array(9999, -9, -10, -11, -1, 1, 9, 10, 11)
        End Select
    End Function

End Class

' *** `؏NNX

Dim clsKAKINOKI_oE, clsKAKINOKI_CMD, clsKAKINOKI_Status, s_TempFileName ' Cxg̎QƗpϐ

Class clsKAKINOKI

    Private po_HTML, po_OnUnload

    Private Sub Class_Initialize()
        Set po_OnUnload = GetRef("clsKAKINOKI_onUL")
        Set po_HTML = CreateObject("HTMLFile") ' VtgL[`FbNp̃IuWFNg
        Call po_HTML.Write("<body></body>")
        Call po_HTML.Close()
        s_TempFileName = o_FileIO.TempFileName
        Call o_KANKYO.Init_KAKINOKI()
    End Sub

    Public Sub getResult(ByVal s_KIf_FileName) ' s_KIf_FileName^Ċ`؂ɉ
        clsKAKINOKI_CMD = o_KANKYO.get_KAKINOKI_FullPath & """" & s_Kif_FileName & """" & o_KANKYO.get_KAKINOKI_Option
        Do
            clsKAKINOKI_Status = 0
            po_HTML.Body.OnUnload = po_OnUnload
            Call po_HTML.Write("<body></body>")
            Call po_HTML.Close()
            Do While clsKAKINOKI_Status = 0
                Call WScript.Sleep(500)
            Loop
        Loop Until clsKAKINOKI_Status = 1
    End Sub

    Private Sub Class_Terminate()
        On Error Resume Next ' `؃NXNÔƂ
            Call o_WSH.Run("powershell -command stop-process -id " & clsKAKINOKI_oE.ProcessID, 0, True)
        On Error GoTo 0
    End Sub

End Class

Public Sub clsKAKINOKI_onUL()
    Dim s_TaskList, s_Text
    If Me.Event.ShiftKey Then
        clsKAKINOKI_Status = -1
        Exit Sub
    End If
    Set clsKAKINOKI_oE = o_WSH.Exec(clsKAKINOKI_CMD)
    s_TaskList = "%comspec% /c TASKLIST /V /FI ""PID EQ " & clsKAKINOKI_oE.ProcessID & """ >""" & s_TempFileName & """"
    Call WScript.Sleep(3000)
    Call o_WSH.Run(s_TaskList, 0, True)
    s_Text = o_FileIO.ReadText(s_TempFileName)
    If clsKAKINOKI_oE.Status = 0 Then
        If InStr(s_Text, "l𓚒") = 0 Then
            Call o_WSH.Run("powershell -command stop-process -id " & clsKAKINOKI_oE.ProcessID, 0, True)
            clsKAKINOKI_Status = -1
            Exit Sub
        End If
    End If
    Do Until clsKAKINOKI_oE.Status = 1
        Call WScript.Sleep(500)
    Loop
    clsKAKINOKI_Status = 1
End Sub

' *** Kif File IONX

Class clsKif_FileIO

    Public Function FileList()
        If WScript.Arguments.Count > 0 Then ' hbOAhhbv̂Ƃ
            FileList = FromArg()
        Else ' tH_KifT
            FileList = FromFolder()
        End If
    End Function
    Private Function FromArg()
        Dim s_FileName(), i_FileCount, s_S, i
        i_FileCount = WScript.Arguments.Count - 1
        ReDim s_FileName(i_FileCount)
        For i = 0 To i_FileCount
            s_S = WScript.Arguments(i)
            If UCase(Right(s_S, 4)) = ".KIF" Then
                If o_FSO.FileExists(s_S) Then
                    s_FileName(i) = s_S
                Else
                    Call o_Console.MsgCritical("̓t@C܂łBi" & s_S & "j")
                End If
            Else
                Call o_Console.MsgExclamation("kifłȂt@C͂܂Bi" & s_S & "j")
            End If
        Next
        FromArg = s_FileName
    End Function
    Private Function FromFolder()
        Dim s_FileName(), i_FileCount, o_Files, o_ExistFile, s_CuDir
        s_CuDir = o_WSH.CurrentDirectory
        Set o_Files = o_FSO.getFolder(s_CuDir).Files
        ReDim s_FileName(o_Files.Count)
        i_FileCount = - 1
        For Each o_ExistFile In o_Files
            If UCase(Right(o_ExistFile.Name, 4)) = ".KIF" Then ' tH_.kift@C
                i_FileCount = i_FileCount + 1
                s_FileName(i_FileCount) = s_CuDir & "\" & o_ExistFile.Name
            End If
        Next
        If i_FileCount < 0 Then Call o_Console.MsgExclamation("kift@C܂B")
        ReDim Preserve s_FileName(i_FileCount)
        FromFolder = s_FileName
    End Function

    Public Function Evaluate(ByVal s_Kif_FileName)
        Evaluate = EvaluateText(o_FileIO.ReadText(s_Kif_FileName))
        If IsEmpty(Evaluate) Then
            Call o_Console.MsgExclamation("kift@Cُ̈łB(1)")
        End If
    End Function

    Public Function EvaluateText(ByVal s_Kif_FileText)
        Dim v_KBF()
        Dim s_BAN(99), i_MOCHI(1, 7), i_From, i_To, i_To_Old, s_KOMA
        Dim i_Kif_Lines
        Dim i_GY_SU, i_TESU, i_TESU_Old, i_SOUTESU
        Dim i_YOKO, i_TATE, i
        Dim s_Kif_FileTextLine, s_SASHITE, s_S, i_Check_Goteban

        EvaluateText = Empty ' Default̖߂l
        s_Kif_FileTextLine = Split(s_Kif_FileText, vbCrLf)
        i_Kif_Lines = UBound(s_Kif_FileTextLine)
        If i_Kif_Lines < 21 Then Exit Function ' Ȃ
        s_Kif_FileText = Replace(s_Kif_FileText, "", "") ' gpՂ̑Ή
        s_Kif_FileText = Replace(s_Kif_FileText, "", "") ' gpՂ̑Ή

        ReDim v_KBF(i_Kif_Lines - 20) ' kift@C̍sɈUő̈Ƃ

        For i = 1 To 7
            i_MOCHI(0, i) = 0
            i_MOCHI(1, i) = 0
        Next

        i_TESU_Old = 0
        i_Check_Goteban = 0
        For i_GY_SU = 0 To i_Kif_Lines
            s_SASHITE = s_Kif_FileTextLine(i_GY_SU)
            If Left(s_SASHITE, 1) = "+" Then
                If i_GY_SU + 12 > i_Kif_Lines Then Call o_Console.MsgExclamation("kift@Cُ̈łB(2)")
                For i_TATE = 1 To 9
                    i_GY_SU = i_GY_SU + 1
                    s_SASHITE = s_Kif_FileTextLine(i_GY_SU)
                    If Len(s_SASHITE) < 20 Then Call o_Console.MsgExclamation("kift@Cُ̈łB(3)")
                    For i_YOKO = 1 To 9
                        s_S = Mid(s_SASHITE, 20 - i_YOKO * 2, 2)
                        If s_S <> " E" Then
                            If (Left(s_S, 1) <> " ") And (Left(s_S, 1) <> "v") Then Call o_Console.MsgExclamation("kift@Cُ̈łB(4)")
                            If InStr("jpʂƈǌ\Sn", Right(s_S, 1)) = 0 Then Call o_Console.MsgExclamation("kift@Cُ̈łB(5)")
                        End If
                        s_BAN(i_TATE * 10 + i_YOKO) = s_S
                    Next
                Next
                i_GY_SU = i_GY_SU + 1
            ElseIf Left(s_SASHITE, 5) = "̎" Then
                Call setMOCHIGOMA(1, Mid(s_SASHITE, 7), i_MOCHI)
            ElseIf Left(s_SASHITE, 5) = "̎" Then
                Call setMOCHIGOMA(0, Mid(s_SASHITE, 7), i_MOCHI)
            ElseIf Left(s_SASHITE, 3) = "" Then
                i_Check_Goteban = 1
            Else
                If Left(s_SASHITE, 4) = "   1" Then Exit For
            End If
        Next

        For i_GY_SU = i_GY_SU To i_Kif_Lines
            s_SASHITE = s_Kif_FileTextLine(i_GY_SU)
            If IsNumeric(Left(s_SASHITE, 4)) Then
                i_TESU = CInt(Left(s_SASHITE, 4))
                If i_TESU = i_TESU_Old + 1 Then
                    If (InStr(s_SASHITE, "l") <> 0) Or (InStr(s_SASHITE, "") <> 0) Or _
                       (InStr(s_SASHITE, "f") <> 0) Or (InStr(s_SASHITE, "") <> 0) Then
                        i_SOUTESU = i_TESU_Old
                        Exit For
                    End If
                    If InStr(s_SASHITE, "") > 0 Then
                        If i_TESU < 2 Then Call o_Console.MsgExclamation("kift@Cُ̈łB(6)")
                        i_To = i_To_Old
                        s_S = Split(s_SASHITE, "(")(1)
                        If IsNumeric(Mid(s_S, 2, 1)) And IsNumeric(Left(s_S, 1)) Then
                            i_From = CInt(Mid(s_S, 2, 1)) * 10 + CInt(Left(s_S, 1))
                        Else
                            Call o_Console.MsgExclamation("kift@Cُ̈łB(7)")
                        End If
                        s_KOMA = FindKOMA(s_SASHITE)
                    Else
                        i_To = InStr("PQRSTUVWX", Mid(s_SASHITE, 6, 1)) + InStr("OlܘZ", Mid(s_SASHITE, 7, 1)) * 10
                        If Mid(s_SASHITE, 9, 1) = "" Then
                            s_S = Mid(s_SASHITE, 8, 1)
                            If InStr("jp", s_S) = 0 Then Call o_Console.MsgExclamation("kift@Cُ̈łB(8)")
                            s_KOMA = s_S
                            i_From = 0
                        Else
                            s_S = Split(s_SASHITE, "(")(1)
                            If IsNumeric(Mid(s_S, 2, 1)) And IsNumeric(Left(s_S, 1)) Then
                                i_From = CInt(Mid(s_S, 2, 1)) * 10 + CInt(Left(s_S, 1))
                            Else
                                Call o_Console.MsgExclamation("kift@Cُ̈łB(9)")
                            End If
                            s_KOMA = FindKOMA(s_SASHITE)
                        End If
                    End If
                End If
                i_TESU_Old = i_TESU
                If i_TESU = 1 Then
                    Set v_KBF(i_TESU) = (New clsSHOGIBAN)(s_BAN, i_MOCHI, (i_Check_Goteban + i_TESU + 1) Mod 2, i_From, i_To, s_KOMA)
                Else
                    Set v_KBF(i_TESU) = v_KBF(i_TESU - 1).Next_Ban(i_From, i_To, s_KOMA)
                End If
                i_To_Old = i_To
                If v_KBF(i_TESU) Is Nothing Then Call o_Console.MsgExclamation("kift@Cُ̈łB(10)")
            End If
        Next

        If i_SOUTESU = 0 Then Call o_Console.MsgExclamation("kift@CɊ܂B")
        If (i_SOUTESU Mod 2) = i_Check_Goteban Then Call o_Console.MsgExclamation("kift@C̎ԂƎ萔܂B")

        v_KBF(0) = i_SOUTESU
        ReDim Preserve v_KBF(i_SOUTESU)
        EvaluateText = v_KBF

    End Function

    Private Function FindKOMA(ByVal s_S) ' Kif̍s̕𒊏o
        Select Case InStr(s_S, "")
            Case 0 'łȂ@܂́@En
                FindKOMA = Mid(s_S, 8, 1)
            Case 8 '̈ړ
                Dim n
                n = InStr("jp", Mid(s_S, 9, 1))
                If n = 0 Then Call o_Console.MsgExclamation("kift@Cُ̈łB(11)")
                FindKOMA = Mid("ƈǌ\Sn", n, 1)
            Case 9 '
                FindKOMA = Mid(s_S, 8, 2)
            Case Else
                Call o_Console.MsgExclamation("kift@Cُ̈łB(12)")
         End Select
    End Function

    Private Sub setMOCHIGOMA(ByVal i_SENTE_GOTE, ByVal s_MOCHI, ByRef i_MOCHI) ' \byRefɃZbg
        Dim s_S, n
        For n = 1 To 7
            i_MOCHI(i_SENTE_GOTE, n) = 0
        Next
        For Each s_S In Split(s_MOCHI, "@") 'Sp󔒂ŋ؂
            n = InStr("jp", Left(s_S, 1))
            If n > 0 Then
                Select Case Len(s_S)
                    Case 1 '̋ނ̌ɐlȂƂ
                        i_MOCHI(i_SENTE_GOTE, n) = 1
                    Case 2 'P
                        i_MOCHI(i_SENTE_GOTE, n) = InStr("OlܘZ\", Right(s_S, 1))
                    Case 3 'Q
                        If Mid(s_S, 2, 1) <> "\" Then Call o_Console.MsgExclamation("kift@Cُ̈łB(13)")
                        i_MOCHI(i_SENTE_GOTE, n) = 10 + InStr("OlܘZ", Right(s_S, 1))
                End Select
            End If
        Next
    End Sub

End Class

' *** ݒlNX

Const clsKANKYO_Data_RegIcon = "HKEY_CURRENT_USER\Software\Kakinoki\KShogi9\Window size\icon"

Class KANKYO_Data

    Private p_KAKINOKI_FullPath, p_KAKINOKI_Option, p_SK_File, p_OK_File

    Public Function get_KAKINOKI_FullPath()
        get_KAKINOKI_FullPath = p_KAKINOKI_FullPath
    End Function
    Public Function get_KAKINOKI_Option()
        get_KAKINOKI_Option = p_KAKINOKI_Option
    End Function

    Public Sub Init_KAKINOKI()
        Call o_FileIO.Copy(p_OK_File, p_SK_File)
        Call o_WSH.RegWrite(clsKANKYO_Data_RegIcon, 1, "REG_DWORD")
    End Sub

    Private Sub Class_Initialize()
        Dim s_S, s_Right, s_Text, i_CHK
        Const c_K_FullPath = "`؏̃tpX"
        Const c_SEIGEN = "菇萧"
        Const c_Version = "ŐṼo[WmF"
        Const s_FileName = "ݒ.txt"
        If o_FSO.FileExists(s_FileName) = False Then 'ݒt@CȂƂݒt@C𐶐ďI
            s_Text = "ϓ`FbNc[ݒV[g" & vbCrLf & vbCrLf
            On Error Resume Next ' `؏CXg[ĂȂƂ
                s_S = Split(o_WSH.RegRead("HKEY_CLASSES_ROOT\KShogi.Kifu\DefaultIcon\"),",")(0)
                If Err.Number Then
                    s_S = ""
                ElseIf UCase(Right(s_S, 11)) <> "KSHOGI9.EXE" Then
                    s_S = ""
                End IF
            On Error GoTo 0
            s_Text = s_Text & c_K_FullPath & "" & s_S & vbCrLf
            s_Text = s_Text & "`؏̃tpXw肵܂Bi@C:\Program Files\Kakinoki\KShogi9\KShogi9.exej" & vbCrLf & vbCrLf & _
                c_SEIGEN & "60" & vbCrLf & _
                "ω̈菇ł̐ԁibjAp̐Ŏw肵܂Biŏ10bBȗƂ3600b1ԁj" & vbCrLf & vbCrLf & _
                c_Version & "͂" & vbCrLf & _
                "s̓sxAc[̃o[WmF܂Hi͂or@ȗ͂jiC^[lbgڑKvłj"
            Call o_FileIO.WriteText(s_FileName, s_Text)
            If s_S = "" Then
                Call o_Console.MsgExclamation("ݒt@CVK쐬܂B" & vbCrLf & "`؏܂łB")
            Else
                Call o_Console.MsgInfo("ݒt@CVK쐬܂B")
            End If
        End If

        i_CHK = 1024
        For Each s_S In Split(o_FileIO.ReadText(s_FileName), vbCrLf)
            If InStr(s_S, "") > 0 Then
                s_Right = Trim(Split(s_S, "")(1))
                Select Case Split(s_S, "")(0)
                    Case c_K_FullPath
                        If (i_CHK And 1) = 0 Then
                            i_CHK = i_CHK + 1
                            If o_FSO.FileExists(s_Right) And (UCase(Right(s_Right, 4)) = ".EXE") And (InStr(UCase(s_Right), "KSHOGI") > 0) Then
                                p_KAKINOKI_FullPath = """" & s_Right & """ "  ' sɃt@CƂ̊Ԃ1
                            Else
                                Call o_Console.MsgExclamation("`؏܂łB")
                            End If
                        Else
                            i_CHK = 2000
                            Exit For
                        End If

                    Case c_SEIGEN
                        If (i_CHK And 4) = 0 Then
                            i_CHK = i_CHK + 2
                            If IsNumeric(s_Right) Then
                                If CDbl(s_Right) < 10 Or CDbl(s_Right) > 864000 Then ' V2.12
                                    p_KAKINOKI_Option = " /Etsume /M3600" '3600b1Ԑ
                                Else
                                    p_KAKINOKI_Option = " /Etsume /M" & CLng(s_Right) ' V2.12
                                End If
                            Else
                                i_CHK = 2000
                                Exit For
                            End If
                        Else
                            i_CHK = 2000
                            Exit For
                        End If

                    Case c_Version
                        If (i_CHK And 16) = 0 Then
                            i_CHK = i_CHK + 4
                            If s_Right <> "" Then Call LoadNewVersion()
                        Else
                            i_CHK = 2000
                            Exit For
                        End If
                End Select
            End If
        Next
        If i_CHK <> (1024 + 7) Then Call o_Console.MsgExclamation("ݒt@CjĂ܂B" & vbCrLf & "i܂̓o[WႢ܂Bj")

        Dim s_KShogiFolder
        s_KShogiFolder = o_WSH.SpecialFolders("Appdata") & "\Kakinoki\KShogi9\"
        p_OK_File = s_KShogiFolder & "tsumeORG.env"
        p_SK_File = s_KShogiFolder & "tsume.env"

        Dim o_CuFile, s_OrgEnvText, s_EnvText
        For Each o_CuFile In o_FSO.getFolder(o_WSH.CurrentDirectory).Files
            If UCase(Right(o_CuFile.Name, 4)) = ".ENV" Then ' tH_̊`؊t@C
                s_OrgEnvText = o_FileIO.ReadText(o_CuFile.Name)
                Exit For
            End If
        Next

        If IsEmpty(s_OrgEnvText) Then ' tH_ENVt@CȂƂ
            If o_FSO.FileExists(s_KShogiFolder & "KShogi9.env") Then
                s_OrgEnvText = o_FileIO.ReadText(s_KShogiFolder & "KShogi9.env")
            Else
                Call o_Console.MsgCritical("`؏ENVt@CjĂ܂B" & vbCrLf & "`؏ɓ삷邩mFĉB")
            End If
        End If

        s_EnvText = ""
        For Each s_S In Split(s_OrgEnvText, vbCrLf)
            Select Case Left(s_S, 8)
                Case "EBhE "
                    s_EnvText = s_EnvText & "EBhE   : 0" & Mid(s_S, 14) & vbCrLf
                Case "EBhE "
                    s_EnvText = s_EnvText & "EBhE   : 0" & Mid(s_S, 14) & vbCrLf
                Case "`EBhE "
                    s_EnvText = s_EnvText & "`EBhE   : 0" & Mid(s_S, 14) & vbCrLf
                Case "bZ[W "
                    s_EnvText = s_EnvText & "bZ[W   : 0" & Mid(s_S, 14) & vbCrLf
                Case Else
                    s_EnvText = s_EnvText & s_S & vbCrLf
            End Select
        Next
        Call o_FileIO.WriteText(p_OK_File, s_EnvText)
        Call o_WSH.RegWrite("HKEY_CURRENT_USER\Control Panel\Desktop\ForegroundLockTimeout", 200000, "REG_DWORD")
    End Sub

    Private Sub LoadNewVersion()
        Dim s_HTTP_Res, s_NewVersionFile
        With CreateObject("MSXML2.ServerXMLHTTP")
            Call .Open("GET", "https://tsume-kobo.org/hendochk/hendo_V.txt", False)
            Call .setRequestHeader("User-Agent", "hendo_" & cs_ThisVersion)
            On Error Resume Next
                Call .Send()
                If (Err.Number <> 0) Or (.Status <> "200") Then Exit Sub ' lbgڑG[𖳎B
            On Error Goto 0

            s_HTTP_Res = .ResponseText
            If Left(s_HTTP_Res, Len(cs_ThisVersion)) <= cs_ThisVersion Then Exit Sub ' XVłȂ
            If MsgBox("XVł܂B" & vbCrLf & s_HTTP_Res & vbCrLf & "XVł_E[h܂H", _
                vbYesNo + vbInformation + vbMsgBoxSetForeground, "ϓ`FbN") <> vbYes Then Exit Sub ' XV邪{Ȃ

            s_NewVersionFile = "hendo" & Mid(s_HTTP_Res, 5, 1) & Mid(s_HTTP_Res, 7, 2) & ".vbs"
            Call .Open("GET", "https://tsume-kobo.org/hendochk/" & s_NewVersionFile & "U", False) ' T[oBOMtUTF-8t@C
            Call .setRequestHeader("User-Agent", "hendo_LoadNewVersion")
            On Error Resume Next
                Call .Send()
                If (Err.Number <> 0) Or (.Status <> "200") Then Call o_Console.MsgExclamation("XVł̃_E[hɎs܂B")
            On Error Goto 0
            s_HTTP_Res = .ResponseText
            If s_HTTP_Res = "" Then Call o_Console.MsgExclamation("XVł̃_E[hɎs܂B")
            Call o_FileIO.WriteText(s_NewVersionFile, s_HTTP_Res)
            Call o_Console.MsgInfo("XVł_E[h܂B")
        End With
    End Sub

    Private Sub Class_Terminate()
        Call o_WSH.RegWrite(clsKANKYO_Data_RegIcon, 0, "REG_DWORD")
    End Sub

End Class

' *** bZ[W\

Class clsConsole

    Private d_StartTime, s_Kif_FileName, i_SOTESU, i_BUNKISU, i_CuTESU, i_KYOKUMENSU, i_HENDO, i_HENCHO, i_Timeout
    Private s_MsgH, s_BAN_0

    Private Sub Class_Initialize()
        d_StartTime = Now()
        s_BAN_0 = ""
    End Sub

    Public Property Let Kif_FileName(ByVal s_S)
        d_StartTime = Now()
        s_Kif_FileName = o_FSO.getFileName(s_S)
        i_HENDO = 0
        i_HENCHO = 0
        i_Timeout = 0
        i_KYOKUMENSU = 0
        s_MsgH = "`؏ŕϓ`FbN " & cs_ThisVersion & " sShiftL[Ȃŉt" & _
                vbCrLf & vbCrLf & s_Kif_FileName & vbCrLf & vbCrLf & d_StartTime & "Jn" & vbCrLf
    End Property
    Public Property Let SOTESU(ByVal n)
        i_SOTESU = n
        i_CuTESU = 1 + (i_SOTESU Mod 2)
    End Property
    Public Property Let BUNKISU(ByVal n)
        i_BUNKISU = n
    End Property
    Public Sub IncIncTE()
        i_CuTESU = i_CuTESU + 2
    End Sub
    Public Sub IncHENDO()
        i_HENDO = i_HENDO + 1
    End Sub
    Public Sub IncHENCHO()
        i_HENCHO = i_HENCHO + 1
    End Sub
    Public Sub IncTimeout()
        i_Timeout = i_Timeout + 1
    End Sub
    Public Sub IncKYOKUMENSU()
        i_KYOKUMENSU = i_KYOKUMENSU + 1
    End Sub
    Public Property Let BANMEN(ByVal s_BAN)
        Call WScript.Echo(vbCrLf & vbCrLf & vbCrLf & s_MsgH & Now() & "" & i_CuTESU & "ڂ" & vbCrLf & _
                "i萔" & i_SOTESU & "@򐔁" & i_BUNKISU & "@ρ" & i_KYOKUMENSU & _
                "i" & FormatNumber(i_KYOKUMENSU * 100 / i_BUNKISU, 1) & "jj" & vbCrLf & vbCrLf & s_BAN)
        If s_BAN_0 = "" Then s_BAN_0 = s_BAN
    End Property
    Public Sub MsgInfo(ByVal s_S)
        Call MsgDisp(s_S, vbInformation)
    End Sub
    Public Sub MsgExclamation(ByVal s_S)
        Call MsgDisp(s_S, vbExclamation)
    End Sub
    Public Sub MsgCritical(ByVal s_S)
        Call MsgDisp(s_S, vbCritical)
    End Sub
    Private Sub MsgDisp(ByVal s_S, ByVal i_StopDlg)
        Call MsgBox(s_S & vbCrLf & "iJn" & d_StartTime & "@I" & Now() & "j",_
            i_StopDlg + vbMsgBoxSetForeground, "ϓ`FbN")
        Call WScript.Quit()
    End Sub
    Public Sub Finish()
        Call WScript.Echo(vbCrLf & "㏈F" & s_Kif_FileName & vbCrLf)
    End Sub
    Public Function Closing()
        Dim ClosingMsg, RetMsg, Msg1, Msg2, Msg3
        Msg1 = d_StartTime & "Jn@" & Now() & "I"
        Msg2 = "i萔" & i_SOTESU & "@򐔁" & i_BUNKISU & "j"
        ClosingMsg = "`؏ŕϓ`FbN " & cs_ThisVersion & vbCrLf & vbCrLf & s_Kif_FileName & vbCrLf & vbCrLf & Msg1 & vbCrLf & Msg2
        RetMsg = s_Kif_FileName & vbCrLf & Msg1 & vbCrLf & Msg2
        If (i_HENDO + i_HENCHO + i_Timeout) > 0 Then
            Msg3 = "iϓ" & i_HENDO & "@ϒ" & i_HENCHO & "@Ԑ؂ꁁ" & i_Timeout & "j"
            ClosingMsg = ClosingMsg & vbCrLf & Msg3
            RetMsg = RetMsg & vbCrLf & Msg3
        End If
        Call o_FileIO.WriteText("Hendo_Kekka.txt", ClosingMsg & vbCrLf & vbCrLf & s_BAN_0)
        Call WScript.Echo(vbCrLf & vbCrLf & vbCrLf & ClosingMsg & vbCrLf & vbCrLf & s_BAN_0)
        s_BAN_0 = ""
        Closing = RetMsg
    End Function

End Class

' *** t@Co͒`NX

Class FileIO

    Public Function ReadText(ByVal s_FileName)
        Dim o_FileObj, i
        For i = 1 To 10
            On Error Resume Next
                Set o_FileObj = o_FSO.OpenTextFile(s_FileName, 1) ' 1=ǂݎ胂[h
                If Err.Number = 0 Then
                    ReadText = o_FileObj.ReadAll
                    o_FileObj.Close()
                    If Err.Number = 0 Then Exit Function
                End If
            On Error GoTo 0
            Call WScript.Sleep(500)
        Next
        Call o_Console.MsgExclamation("t@ChnG[ł(1)i" & s_FileName & "jB")
    End Function
    Public Sub WriteText(ByVal s_FileName, ByVal s_Text)
        Dim o_FileObj, i
        For i = 1 To 10
            On Error Resume Next
                Set o_FileObj = o_FSO.OpenTextFile(s_FileName, 2, True) '2=㏑[h, true=VKt@C쐬
                If Err.Number = 0 Then
                    Call o_FileObj.Write(s_Text)
                    Call o_FileObj.Close()
                    If Err.Number = 0 Then Exit Sub
                End If
            On Error GoTo 0
            Call WScript.Sleep(500)
        Next
        Call o_Console.MsgExclamation("t@ChnG[ł(2)i" & s_FileName & "jB")
    End Sub
    Public Sub Delete(ByVal s_FileName)
        Dim i
        If Not o_FSO.FileExists(s_FileName) Then Exit Sub
        For i = 1 To 10
            On Error Resume Next
                Call o_FSO.DeleteFile(s_FileName, True)
                If Err.Number = 0 Then Exit Sub
            On Error GoTo 0
            Call WScript.Sleep(500)
        Next
        Call o_Console.MsgExclamation("t@ChnG[ł(3)i" & s_FileName & "jB")
    End Sub
    Public Sub DeleteFolder(ByVal s_FolderName)
        Dim i
        If o_FSO.FolderExists("""" & s_FolderName & """") Then Exit Sub
        For i = 1 To 10
            On Error Resume Next
                Call o_FSO.DeleteFolder(s_FolderName, True)
                If Err.Number = 0 Then Exit Sub
            On Error GoTo 0
            Call WScript.Sleep(500)
        Next
        Call o_Console.MsgExclamation("t@ChnG[ł(4)i" & s_FolderName & "jB")
    End Sub
    Public Sub Copy(ByVal s_From, ByVal s_To)
        Dim i
        For i = 1 To 10
            On Error Resume Next
                Call o_FSO.CopyFile(s_From, s_To)
                If Err.Number = 0 Then Exit Sub
            On Error GoTo 0
            Call WScript.Sleep(500)
        Next
        Call o_Console.MsgExclamation("t@ChnG[ł(5)i" & s_From & "," & s_To &"jB")
    End Sub
    Public Function TempFileName()
        TempFileName = o_WSH.SpecialFolders("Templates") & "\Hendo.tmp"
    End Function

End Class

' *** rt@CpNX

Class LockFile

    Private ps_FileName, po_LockFile
    Private Sub Class_Initialize()
        ps_FileName = o_WSH.SpecialFolders("Templates") & "\HendodNh~"
        On Error Resume Next
            Set po_LockFile = o_FSO.CreateTextFile(ps_FileName, True)
            If Err.Number <> 0 Then
                On Error GoTo 0
                Call MsgBox("dNł܂B", vbExclamation + vbMsgBoxSetForeground, "ϓ`FbN") ' ConsoleĂ΂ɏI
                Call WScript.Quit()
            End If
        On Error GoTo 0
    End Sub
    Private Sub Class_Terminate()
        If Not IsEmpty(po_LockFile) Then
            Call po_LockFile.Close()
            Call o_FileIO.Delete(ps_FileName)
        End If
    End Sub

End Class

' *** ꎞt@CpNX

Class TempFiles

    Private ps_TempFolderName, ps_TempLockName, po_TempLockFile, ps_CurLockName, po_CurLockFile
    Private Sub Class_Initialize()
        ps_TempFolderName = o_WSH.SpecialFolders("Templates") & "\" & Replace(Replace(Replace(Now(), "/", ""), ":", ""), " ", "_")
        ps_TempLockName = ps_TempFolderName & "\폜h~"
        ps_CurLockName = o_WSH.CurrentDirectory & "\폜h~"
        On Error Resume Next
            Call o_FSO.CreateFolder(ps_TempFolderName)
            Set po_TempLockFile = o_FSO.CreateTextFile(ps_TempLockName, True)
            If Err.Number <> 0 Then
                On Error GoTo 0
                Call o_Console.MsgExclamation("t@ChnG[ł(6)i" & ps_TempFolderName & "jB")
            End If
            Set po_CurLockFile = o_FSO.CreateTextFile(ps_CurLockName, True)
            If Err.Number <> 0 Then
                On Error GoTo 0
                Call o_Console.MsgExclamation("t@ChnG[ł(7)i" & ps_CurLockName & "jB")
            End If
        On Error GoTo 0
    End Sub
    Public Function FolderName()
        FolderName = ps_TempFolderName
    End Function
    Private Sub Class_Terminate()
        If Not IsEmpty(po_CurLockFile) Then
            Call po_CurLockFile.Close()
            Call o_FileIO.Delete(ps_CurLockName)
        End If
        If Not IsEmpty(po_TempLockFile) Then
            Call po_TempLockFile.Close()
            Call o_FileIO.Delete(ps_TempLockName)
        End If
        Call o_FileIO.DeleteFolder(ps_TempFolderName)
    End Sub

End Class